unit Main_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SDUFrames, SDUFilenameEdit_U, StdCtrls,
  SDUForms;

type
  TForm1 = class(TSDUForm)
    Label1: TLabel;
    pbProcess: TButton;
    pbClose: TButton;
    feInput: TSDUFilenameEdit;
    Label2: TLabel;
    feOutput: TSDUFilenameEdit;
    Label3: TLabel;
    procedure pbCloseClick(Sender: TObject);
    procedure pbProcessClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  SDUDialogs;

procedure TForm1.FormShow(Sender: TObject);
begin
  self.Caption := Application.Title;
end;

procedure TForm1.pbCloseClick(Sender: TObject);
begin
  Close();
end;

procedure TForm1.pbProcessClick(Sender: TObject);
var
  fileContent: TStringList;
  i: integer;
  j: integer;
  lastChar: char;
  nextParamIdx: integer;
  addChar: string;
  newLine: string;
begin
  fileContent:= TStringList.Create();
  try
    fileContent.LoadFromFile(feInput.Filename);

    nextParamIdx := 1;
    for i:=0 to (fileContent.count - 1) do
      begin
      newLine := '';
      
      if (
          (Pos('msgid', fileContent[i]) = 1) or
          (Pos('msgstr', fileContent[i]) = 1)
         ) then
        begin
        nextParamIdx := 1;
        end;

      lastChar := #0;
      for j:=1 to length(fileContent[i]) do
        begin
        addChar := fileContent[i][j];
        if (lastChar = '%') then
          begin
          if (
              (addChar = 'd') or
              (addChar = 'c') or
              (addChar = 's')
             ) then
            begin
            addChar := inttostr(nextParamIdx);
            inc(nextParamIdx);
            end;
          end;


        newLine := newLine + addChar;

        lastChar := fileContent[i][j];
        end;

      fileContent[i] := newLine;
      end;

    fileContent.SaveToFile(feOutput.Filename);

    SDUMessageDlg('Translation file processed OK.', mtInformation);

  finally
    fileContent.Free();
  end;

end;

END.

